----------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity refresh is
		generic(sim : boolean := false; N : positive := 7); -- default 150MHz, if clk is 200MHz, set N to 9
    Port ( clk : in std_logic;
           lock : in std_logic;
           init_done : in std_logic;
           start_init : out std_logic;
           ddr_csn : out std_logic;
           ddr_clke : out std_logic;
           tc_out : out std_logic;
           ref : out std_logic);
end refresh;

architecture refresh_arch of refresh is
signal clke,tc: std_logic :='0';
signal startup: std_logic_vector(4 downto 0) := (others =>'0');
signal div: std_logic_vector(10 downto 0) :=(others =>'0');
begin
ddr_clke <= clke;
tc_out <= tc;
-- refresh signal generator
process(clk,lock)
begin
  if(lock = '0')then
    tc <= '0';
    ref <= '0';
    clke <= '0';
    start_init <= '0';
    ddr_csn <= '1';
		if(sim)then
			startup <= "11010";
		else
			startup <= (others => '0');
		end if;
		div <= (others => '0');
  elsif(clk'event and clk = '1')then
    ddr_csn <= '0';
    if(startup = "11011" and tc = '1')then
      start_init <= '1';
      clke <= '1';
    else
      start_init <= '0';
    end if;
    ref <= tc and clke;
		if(init_done = '1')then
			startup <= (others => '1');
		elsif(tc = '1')then
			startup <= startup + 1;
		end if;
--		if((not sim and div(10) = '1' and div(N) = '1') or (sim and div(7) = '1'))then -- 7.68us refresh period
		if((sim and div(7) = '1') or (not sim and (
																	(N = 1 and div(9) = '1' and div(8) = '1') or
																	(N = 7 and div(10) = '1' and div(7) = '1') or
																	(N = 9 and div(10) = '1' and div(9) = '1') )))then
			div <= (others => '0');
			tc <= '1';
		else
			div <= div + 1;
			tc <= '0';
		end if;
  end if;
end process;
end refresh_arch;
