----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:14:48 02/04/2009 
-- Design Name: 
-- Module Name:    ch_link - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity ch_link is
    Port ( trig : in  STD_LOGIC;
					 ttc_clk : in STD_LOGIC;
					 lrb_ch : in STD_LOGIC_VECTOR (3 downto 0);
					 bcnt_res : in STD_LOGIC;
					 evcnt_res : in STD_LOGIC;
           cl_data : out  STD_LOGIC_VECTOR (4 downto 0));
end ch_link;

architecture Behavioral of ch_link is
component hamcode_gen
	port(clk : in std_logic;
			 s : in std_logic_vector(1 downto 0);
			 d : in std_logic_vector(15 downto 0);
			 l2frame : in std_logic_vector(23 downto 0));
end component;
signal clk :std_logic := '0';
signal idle_cntr :std_logic_vector(3 downto 0) := (others => '0');
signal evt_cntr :std_logic_vector(7 downto 0) := (others => '0');
signal s :std_logic_vector(1 downto 0) := (others => '0');
signal sr :std_logic_vector(27 downto 0) := (others => '0');
signal div :std_logic_vector(2 downto 0) := (others => '0');
signal cntr :std_logic_vector(7 downto 0) := (others => '0');
signal ev_data :std_logic_vector(16 downto 0) := (others => '0');
signal evn :std_logic_vector(15 downto 0) := (others => '0');
signal l1_evn :std_logic_vector(32 downto 0) := (others => '0');
signal bcnt :std_logic_vector(11 downto 0) := (others => '0');
signal oc :std_logic_vector(4 downto 0) := (others => '0');
signal trig_tgl :std_logic := '0';
signal trig_sync :std_logic_vector(2 downto 0) := (others => '0');
signal send_data :std_logic := '0';
signal l2frame :std_logic_vector(23 downto 0) := (others => '0');
signal l2framep :std_logic_vector(23 downto 0) := (others => '0');
begin
clk <= not clk after 1.78 ns;
i_ham: hamcode_gen
	port map( clk => clk,
						s => s,
						d => ev_data(15 downto 0),
						l2frame => l2frame);
s <= ev_data(16) & '0';
cl_data <= div(2) & sr(27 downto 24);
l2framep(23) <= l2frame(23);
l2framep(22) <= l2frame(13);
l2framep(21) <= l2frame(5);
l2framep(20 downto 14) <= l2frame(20 downto 14);
l2framep(13) <= l2frame(22);
l2framep(12 downto 6) <= l2frame(12 downto 6);
l2framep(5) <= '0';
l2framep(4 downto 0) <= l2frame(4 downto 0);
process(ttc_clk)
begin
	if(ttc_clk'event and ttc_clk = '1')then
		if(bcnt_res = '1')then
			bcnt <= (others => '0');
			oc <= oc + 1;
		else
			bcnt <= bcnt + 1;
		end if;
		if(evcnt_res = '1')then
			evn <= x"0001";
		elsif(trig = '1')then
			evn <= evn + 1;
		end if;
		if(trig = '1')then
			l1_evn <= oc & bcnt & evn;
			trig_tgl <= not trig_tgl;
		end if;
	end if;
end process;
process(clk)
begin
	if(clk'event and clk = '1')then
		if(div = "110")then
			div <= "000";
			trig_sync <= trig_sync(1 downto 0) & trig_tgl;
			if(trig_sync(2) /= trig_sync(1))then
				send_data <= '1';
			elsif(cntr = x"49" and div = "110")then
				send_data <= '0';
			end if;
			if(send_data = '0')then
				cntr <= x"00";
			else
				cntr <= cntr + 1;
			end if;
		else
			div <= div + 1;
		end if;
		if(send_data = '0')then
			ev_data <= (others => '0');
		elsif(cntr = x"00")then
			ev_data <= '1' & x"0" & lrb_ch & l1_evn(7 downto 0);
		elsif(cntr = x"01")then
			ev_data <= '1' & x"00" & l1_evn(15 downto 8);
		elsif(cntr = x"02")then
			ev_data <= '1' & x"8000";
		elsif(cntr = x"03")then
			ev_data <= '1' & l1_evn(32 downto 28) & "000" & x"00";
		elsif(cntr = x"04")then
			ev_data <= '1' & x"5" & l1_evn(27 downto 16);
		elsif(cntr = x"49")then
			ev_data <= '0' & l1_evn(7 downto 0) & x"00";
		else
			ev_data <= '1' & lrb_ch & x"0" & cntr;
		end if;
		if(div = "001")then
			sr(27) <= l2framep(23);
			sr(26) <= '0';
			sr(25) <= l2framep(18);
			sr(24) <= l2framep(7);
			sr(23) <= l2framep(17);
			sr(22) <= '0';
			sr(21) <= l2framep(15);
			sr(20) <= l2framep(6);
			sr(19) <= l2framep(16);
			sr(18) <= '0';
			sr(17) <= l2framep(14);
			sr(16) <= l2framep(4);
			sr(15) <= l2framep(11);
			sr(14) <= l2framep(22);
			sr(13) <= l2framep(13);
			sr(12) <= l2framep(3);
			sr(11) <= l2framep(10);
			sr(10) <= l2framep(21);
			sr(9) <= l2framep(12);
			sr(8) <= l2framep(2);
			sr(7) <= l2framep(5);
			sr(6) <= l2framep(20);
			sr(5) <= l2framep(9);
			sr(4) <= l2framep(1);
			sr(3) <= '0';
			sr(2) <= l2framep(19);
			sr(1) <= l2framep(8);
			sr(0) <= l2framep(0);
		else
			sr <= sr(23 downto 0) & x"0";
		end if;
	end if;
end process;

end Behavioral;

