----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:15:02 01/12/2009 
-- Design Name: 
-- Module Name:    counters - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use mylib.dcc_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity counters is
		generic (cntr_length : integer := 12);
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           strobe : in  STD_LOGIC;
           uerr : in  STD_LOGIC_VECTOR (2 downto 0);
           cerr : in  STD_LOGIC_VECTOR (2 downto 0);
           lfifo0_data : in  STD_LOGIC_VECTOR (32 downto 0);
           lfifo1_data : in  STD_LOGIC_VECTOR (32 downto 0);
           lfifo2_data : in  STD_LOGIC_VECTOR (32 downto 0);
           lfifo_we : in  STD_LOGIC_VECTOR (2 downto 0);
           addr : in  STD_LOGIC_VECTOR (9 downto 0);
           dout : out  STD_LOGIC_VECTOR (31 downto 0));
end counters;

architecture Behavioral of counters is
signal d_cerr_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal cerr_cntrp: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal cerr_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal d_uerr_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal uerr_cntrp: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal uerr_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal d_wc: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal wcp: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal wc: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal d_u_evt_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal u_evt_cntrp: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal u_evt_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal d_c_evt_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal c_evt_cntrp: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal c_evt_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal d_crc_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal crc_cntrp: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal crc_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal d_trunc_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal trunc_cntrp: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal trunc_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal d_badid_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal badid_cntrp: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal badid_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal d_evt_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal evt_cntrp: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal evt_cntr: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal cerr_wa: std_logic_vector(3 downto 0) := (others => '0');
signal uerr_wa: std_logic_vector(3 downto 0) := (others => '0');
signal wc_wa: std_logic_vector(3 downto 0) := (others => '0');
signal evt_cntr_wa: std_logic_vector(3 downto 0) := (others => '0');
signal c_evt_cntr_wa: std_logic_vector(3 downto 0) := (others => '0');
signal u_evt_cntr_wa: std_logic_vector(3 downto 0) := (others => '0');
signal crc_cntr_wa: std_logic_vector(3 downto 0) := (others => '0');
signal badid_cntr_wa: std_logic_vector(3 downto 0) := (others => '0');
signal trunc_cntr_wa: std_logic_vector(3 downto 0) := (others => '0');
signal cntr_ra: std_logic_vector(3 downto 0) := (others => '0');
signal c_evt_bit : std_logic := '0';
signal u_evt_bit : std_logic := '0';
signal crc_bit : std_logic := '0';
signal badid_bit : std_logic := '0';
signal trunc_bit : std_logic := '0';
signal rst_cycle : std_logic := '0';
signal scan_phase: std_logic_vector(1 downto 0) := (others => '0');
signal scan: std_logic_vector(5 downto 0) := (others => '0');
signal we_evt_cntrp : std_logic := '0';
signal we_evt_cntr : std_logic := '0';
signal we_uerr_cntrp : std_logic := '0';
signal we_cerr_cntrp : std_logic := '0';
signal we_wcp : std_logic := '0';
signal we_uerr_cntr : std_logic := '0';
signal we_cerr_cntr : std_logic := '0';
signal we_wc : std_logic := '0';
signal lrb_ch: std_logic_vector(1 downto 0) := (others => '0');
signal counter_di: std_logic_vector(35 downto 0) := (others => '0');
signal counter_do: std_logic_vector(35 downto 0) := (others => '0');
signal counter_dop: std_logic_vector(35 downto 0) := (others => '0');
signal counter_wa: std_logic_vector(8 downto 0) := (others => '0');
signal counter_ra: std_logic_vector(8 downto 0) := (others => '0');
signal addr0_q : std_logic := '0';
signal we_counter : std_logic := '0';
signal counter_h: std_logic_vector(15 downto 0) := (others => '0');
signal counter_l: std_logic_vector(cntr_length-1 downto 0) := (others => '0');
signal we_carry_quep : std_logic := '0';
signal we_carry_que : std_logic := '0';
signal c_found : std_logic := '0';
signal we_saved_c : std_logic := '0';
signal carry_que_d: std_logic_vector(8 downto 0) := (others => '0');
signal carry_que_o: std_logic_vector(8 downto 0) := (others => '0');
signal carry_wa: std_logic_vector(3 downto 0) := (others => '0');
signal carry_ra: std_logic_vector(3 downto 0) := (others => '0');
signal carry_sr: std_logic_vector(8 downto 0) := (others => '0');
signal saved_c : std_logic_vector(1 downto 0) := (others => '0');

begin
process(clk)
begin
	if(clk'event and clk = '1')then
--		if(strobe = '1')then
			we_evt_cntrp <= lfifo0_data(32) or lfifo1_data(32) or lfifo2_data(32);
			c_evt_bit <= lfifo0_data(16) or lfifo1_data(16) or lfifo2_data(16); -- CERR
			u_evt_bit <= lfifo0_data(17) or lfifo1_data(17) or lfifo2_data(17); -- UERR
			trunc_bit <= lfifo0_data(18) or lfifo1_data(18) or lfifo2_data(18); -- truncate error
			badid_bit <= lfifo0_data(19) or lfifo1_data(19) or lfifo2_data(19); -- badID
			crc_bit <= lfifo0_data(20) or lfifo1_data(20) or lfifo2_data(20); -- CRC error
			if(rst_cycle = '1')then
				lrb_ch(1) <= not lrb_ch(1) and lrb_ch(0);
				lrb_ch(0) <= not lrb_ch(1) and not lrb_ch(0);
			else
				lrb_ch(0) <= not lfifo_we(2) and not lfifo_we(0) and (lfifo_we(1) or lrb_ch(0));
				lrb_ch(1) <= not lfifo_we(1) and not lfifo_we(0) and (lfifo_we(2) or lrb_ch(1));
			end if;
			we_cerr_cntrp <= or_reduce(cerr);
			we_uerr_cntrp <= or_reduce(uerr);
			we_wcp <= or_reduce(lfifo_we);
--			we_wcp <= lfifo_we(0) or lfifo_we(1) or lfifo_we(2);
			we_carry_quep <= rst_cycle or (we_wcp and not or_reduce(lfifo_we));
		if(strobe = '1')then
			if(reset = '1')then
				rst_cycle <= '1';
			elsif(scan(5 downto 3) = "101")then
				rst_cycle <= '0';
			end if;
			if(rst_cycle = '1')then
				scan_phase <= "10";
			else
				scan_phase(1) <= not scan_phase(1) and scan_phase(0);
				scan_phase(0) <= not scan_phase(1) and not scan_phase(0);
			end if;
			if(reset = '1' and rst_cycle = '0')then
				scan <= (others => '0');
			elsif(scan_phase(1) = '1')then
				if(scan(3) = '1')then
					scan(5) <= not scan(5) and scan(4);
					scan(4) <= not scan(5) and not scan(4);
					scan(3 downto 0) <= x"0";
				else
					scan(3 downto 0) <= scan(3 downto 0) + 1;
				end if;
			end if;
			addr0_q <= addr(0);
			if(addr0_q = '0')then
				counter_h(cntr_length+3 downto 0) <= counter_do(35 downto 32-cntr_length);
			end if;
			case addr(4 downto 3) is
				when "00" => counter_l <= wc or cerr_cntr or uerr_cntr or evt_cntr;
				when "01" => counter_l <= badid_cntr or trunc_cntr or c_evt_cntr or u_evt_cntr;
				when others => counter_l <= crc_cntr;
			end case;
			if(rst_cycle = '1')then
				carry_sr <= (others => '0');
			elsif(scan_phase(1) = '1')then
				if(scan(3) = '1')then
					carry_sr <= carry_que_o;
				else
					carry_sr <= carry_sr(7 downto 0) & '0';
				end if;
			end if;
			if(rst_cycle = '1')then
				counter_di <= (others => '0');
			elsif(scan_phase(0) = '1')then
				counter_di <= counter_dop + 1;
			end if;
			if(rst_cycle = '1')then
				we_counter <= '1';
			else
				we_counter <= c_found;
			end if;
			if(scan_phase = "00" and saved_c(1) = '1' and carry_sr(8) = '0')then
				c_found <= '1'; 
			else
				c_found <= '0'; 
			end if;
		end if;
	end if;
end process;
i_cerr_cntr : ram16XNd
    generic map( N => cntr_length)
    port map(
        clk => clk,
        we => we_cerr_cntr, 
        d => d_cerr_cntr,
        a => cerr_wa,
        dpra => cntr_ra,
        spo => cerr_cntrp,
        dpo => cerr_cntr);			
--we_cerr_cntr <= strobe and (we_cerr_cntrp or rst_cycle);
we_cerr_cntr <= we_cerr_cntrp or rst_cycle;
d_cerr_cntr <= (others => '0') when rst_cycle = '1' else cerr_cntrp + 1;
cerr_wa <= "01" & lrb_ch;
cntr_ra <= addr(2 downto 1) & addr(7 downto 6);
i_uerr_cntr: ram16XNd
    generic map( N => cntr_length)
    port map(
        clk => clk,
        we => we_uerr_cntr, 
        d => d_uerr_cntr,
        a => uerr_wa,
        dpra => cntr_ra,
        spo => uerr_cntrp,
        dpo => uerr_cntr);			
--we_uerr_cntr <= strobe and (we_uerr_cntrp or rst_cycle);
we_uerr_cntr <= we_uerr_cntrp or rst_cycle;
d_uerr_cntr <= (others => '0') when rst_cycle = '1' else uerr_cntrp + 1;
uerr_wa <= "10" & lrb_ch;
i_word_cntr: ram16XNd
    generic map( N => cntr_length)
    port map(
        clk => clk,
        we => we_wc, 
        d => d_wc,
        a => wc_wa,
        dpra => cntr_ra,
        spo => wcp,
        dpo => wc);			
--we_wc <= strobe and (we_wcp or rst_cycle);
we_wc <= we_wcp or rst_cycle;
d_wc <= (others => '0') when rst_cycle = '1' else wcp + 1;
wc_wa <= "00" & lrb_ch;
i_evt_cntr: ram16XNd
    generic map( N => cntr_length)
    port map(
        clk => clk,
        we => we_evt_cntr, 
        d => d_evt_cntr,
        a => evt_cntr_wa,
        dpra => cntr_ra,
        spo => evt_cntrp,
        dpo => evt_cntr);			
--we_evt_cntr <= strobe and (we_evt_cntrp or rst_cycle);
we_evt_cntr <= we_evt_cntrp or rst_cycle;
d_evt_cntr <= (others => '0') when rst_cycle = '1' else evt_cntrp + 1;
evt_cntr_wa <= "11" & lrb_ch;
i_crc_cntr: ram16XNd
    generic map( N => cntr_length)
    port map(
        clk => clk,
        we => we_evt_cntr, 
        d => d_crc_cntr,
        a => crc_cntr_wa,
        dpra => cntr_ra,
        spo => crc_cntrp,
        dpo => crc_cntr);			
d_crc_cntr <= (others => '0') when rst_cycle = '1' else crc_cntrp + crc_bit;
crc_cntr_wa <= "00" & lrb_ch;
i_c_evt_cntr: ram16XNd
    generic map( N => cntr_length)
    port map(
        clk => clk,
        we => we_evt_cntr, 
        d => d_c_evt_cntr,
        a => c_evt_cntr_wa,
        dpra => cntr_ra,
        spo => c_evt_cntrp,
        dpo => c_evt_cntr);			
d_c_evt_cntr <= (others => '0') when rst_cycle = '1' else c_evt_cntrp + c_evt_bit;
c_evt_cntr_wa <= "00" & lrb_ch;
i_u_evt_cntr: ram16XNd
    generic map( N => cntr_length)
    port map(
        clk => clk,
        we => we_evt_cntr, 
        d => d_u_evt_cntr,
        a => u_evt_cntr_wa,
        dpra => cntr_ra,
        spo => u_evt_cntrp,
        dpo => u_evt_cntr);			
d_u_evt_cntr <= (others => '0') when rst_cycle = '1' else u_evt_cntrp + u_evt_bit;
u_evt_cntr_wa <= "01" & lrb_ch;
i_badid_cntr: ram16XNd
    generic map( N => cntr_length)
    port map(
        clk => clk,
        we => we_evt_cntr, 
        d => d_badid_cntr,
        a => badid_cntr_wa,
        dpra => cntr_ra,
        spo => badid_cntrp,
        dpo => badid_cntr);			
d_badid_cntr <= (others => '0') when rst_cycle = '1' else badid_cntrp + badid_bit;
badid_cntr_wa <= "11" & lrb_ch;
i_trunc_cntr: ram16XNd
    generic map( N => cntr_length)
    port map(
        clk => clk,
        we => we_evt_cntr, 
        d => d_trunc_cntr,
        a => trunc_cntr_wa,
        dpra => cntr_ra,
        spo => trunc_cntrp,
        dpo => trunc_cntr);			
d_trunc_cntr <= (others => '0') when rst_cycle = '1' else trunc_cntrp + trunc_bit;
trunc_cntr_wa <= "10" & lrb_ch;
i_carry_que : ram16XNd
    generic map( N => 9)
    port map(
        clk => clk,
        we => we_carry_que, 
        d => carry_que_d,
        a => carry_wa,
        dpra => carry_ra,
        dpo => carry_que_o);			
carry_que_d(8) <= wcp(cntr_length-1);
carry_que_d(7) <= cerr_cntrp(cntr_length-1);
carry_que_d(6) <= uerr_cntrp(cntr_length-1);
carry_que_d(5) <= evt_cntrp(cntr_length-1);
carry_que_d(4) <= c_evt_cntrp(cntr_length-1);
carry_que_d(3) <= u_evt_cntrp(cntr_length-1);
carry_que_d(2) <= trunc_cntrp(cntr_length-1);
carry_que_d(1) <= badid_cntrp(cntr_length-1);
carry_que_d(0) <= crc_cntrp(cntr_length-1);
carry_wa <= "00" & lrb_ch;
carry_ra <= "00" & scan(4) & (scan(5) xnor scan(4));
--we_carry_que <= strobe and we_carry_quep;
we_carry_que <= we_carry_quep;
i_saved_carry0 : SRLC16E
   port map (
      Q15 => saved_c(0),   -- Carry output (connect to next SRL)
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '1',     -- Select[3] input
      CE => we_saved_c,     -- Clock enable input
      CLK => clk,   -- Clock input
      D => carry_sr(8)        -- SRL data input
   );
i_saved_carry1 : SRLC16E
   port map (
      Q => saved_c(1),       -- SRL data output
      A0 => '0',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '0',     -- Select[2] input
      A3 => '1',     -- Select[3] input
      CE => we_saved_c,     -- Clock enable input
      CLK => clk,   -- Clock input
      D => saved_c(0)        -- SRL data input
   );
we_saved_c <= scan_phase(1) and strobe;
i_counter : RAMB16_S36_S36
   generic map(SIM_COLLISION_CHECK => "NONE")
   port map (
      DOB => counter_do(31 downto 0),      -- Port B 32-bit Data Output
      DOPB => counter_do(35 downto 32),      -- Port B 4-bit parity Output
      DOA => counter_dop(31 downto 0),      -- Port A 32-bit Data Output
      DOPA => counter_dop(35 downto 32),      -- Port A 4-bit parity Output
      ADDRA => counter_wa,  -- Port A 9-bit Address Input
      ADDRB => counter_ra,  -- Port B 9-bit Address Input
      CLKA => clk,    -- Port A 1-bit Clock
      CLKB => clk,    -- Port B 1-bit Clock
      DIA => counter_di(31 downto 0),      -- Port A 32-bit Data Input
      DIB => x"00000000",      -- Port B 32-bit Data Input
      DIPA => counter_di(35 downto 32),    -- Port A 4-bit parity Input
      DIPB => x"0",    -- Port-B 4-bit parity Input
      ENA => strobe,      -- Port A 1-bit RAM Enable Input
      ENB => strobe,      -- Port B 1-bit RAM Enable Input
      SSRA => '0',    -- Port A 1-bit Synchronous Set/Reset Input
      SSRB => '0',    -- Port B 1-bit Synchronous Set/Reset Input
      WEA => we_counter,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
counter_wa <= "00" & scan(5 downto 4) & '0' & scan(3 downto 0);
counter_ra <= "00" & addr(7 downto 6) & '0' & addr(4 downto 1);
dout <= x"0000" & counter_h when addr(0) = '1' else counter_do(31-cntr_length downto 0) & counter_l;
end Behavioral;

