--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   14:11:20 07/21/2008
-- Design Name:   
-- Module Name:   C:/iseproj/VME_dcc/u2/deser_tb.vhd
-- Project Name:  u2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: deser
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY deser_tb IS
END deser_tb;
 
ARCHITECTURE behavior OF deser_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT deser
    PORT(
         clk : IN  std_logic;
         clk_chk : IN  std_logic;
         l_clk_p : IN  std_logic;
         l_clk_n : IN  std_logic;
         l_data_p : IN  std_logic_vector(3 downto 0);
         l_data_n : IN  std_logic_vector(3 downto 0);
         polarity : in  STD_LOGIC_VECTOR (3 downto 0); -- link data in polarity correction
         l_clkout : OUT  std_logic;
         strobe : OUT  std_logic;
         q : OUT  std_logic_vector(27 downto 0);
         deser_status : OUT  std_logic_vector(2 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal clk_chk : std_logic := '0';
   signal l_clk_p : std_logic := '0';
   signal l_clk_n : std_logic := '0';
   signal l_data_p : std_logic_vector(3 downto 0) := (others => '0');
   signal l_data_n : std_logic_vector(3 downto 0) := (others => '0');

 	--Outputs
   signal l_clkout : std_logic;
   signal strobe : std_logic;
   signal q : std_logic_vector(27 downto 0);
   signal deser_status : std_logic_vector(2 downto 0);

   -- Clock period definitions
   constant clk_period : time := 8ns;
   constant l_clk_period : time := 24.9ns;
 
   signal l_clk : std_logic := '0';
   signal cntr : std_logic_vector(7 downto 0) := (others => '0');
   signal clk7x : std_logic := '1';
   signal cntr_l : std_logic_vector(3 downto 0) := (others => '0');
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: deser PORT MAP (
          clk => clk,
          clk_chk => clk_chk,
          l_clk_p => l_clk_p,
          l_clk_n => l_clk_n,
          l_data_p => l_data_p,
          l_data_n => l_data_n,
					polarity => x"0",
          l_clkout => l_clkout,
          strobe => strobe,
          q => q,
          deser_status => deser_status
        );

   -- Clock process definitions
process(clk7x)
begin
  if(clk7x'event and clk7x = '1')then
		cntr_l <= cntr_l + 1;
	end if;
end process; 
l_data_p <= cntr_l;
l_data_n <= not cntr_l;
clk7x <= not clk7x after l_clk_period/14;
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 
   l_clk_process :process
   begin
		l_clk <= '0';
		wait for l_clk_period*4/7;
		l_clk <= '1';
		wait for l_clk_period*3/7;
   end process;
l_clk_p <= l_clk;
l_clk_n <= not l_clk;
process(clk)
begin
  if(clk'event and clk = '1')then
	  if(cntr = x"f0")then
		  cntr <= x"00";
--			clk_chk <= '1';
		else
		  cntr <= cntr + 1;
--			clk_chk <= '0';
		end if;
	end if;
end process; 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for 100ms;	

      wait for clk_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
