--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   19:34:46 04/11/2008
-- Design Name:   
-- Module Name:   C:/iseproj/VME_dcc/u2/hamming_tb.vhd
-- Project Name:  u2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: Hamming
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY hamming_tb IS
END hamming_tb;
 
ARCHITECTURE behavior OF hamming_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT Hamming
    PORT(
         clk : IN  std_logic;
         din : IN  std_logic_vector(23 downto 0);
         cc_ecc : IN  std_logic;
         dout : OUT  std_logic_vector(19 downto 0);
         cc_rxena : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal din : std_logic_vector(23 downto 0) := (others => '0');
   signal cc_ecc : std_logic := '1';
   signal cc_rxena : std_logic := '1';

 	--Outputs
   signal dout : std_logic_vector(19 downto 0);

   -- Clock period definitions
   constant clk_period : time := 25ns;

   signal cnt : std_logic_vector(15 downto 0) := (others => '0');
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: Hamming PORT MAP (
          clk => clk,
          din => din,
          cc_ecc => cc_ecc,
          dout => dout,
          cc_rxena => cc_rxena
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;

din <= x"02c4b9" when cnt < x"0010" else x"02c0ac" when cnt > x"0020" else x"02b0ac";
process(clk)
begin
  if(clk'event and clk = '1')then
    cnt <= cnt + 1;
  end if;
end process; 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for 100ms;	

      wait for clk_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
