--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   06:39:57 02/03/2009
-- Design Name:   
-- Module Name:   C:/iseproj/VME_dcc/LRB/lrb_tb.vhd
-- Project Name:  LRB
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: LRB
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee,mylib;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
use mylib.dcc_pack.all;
library UNISIM;
use UNISIM.VComponents.all;
 
ENTITY lrb_tb IS
END lrb_tb;
 
ARCHITECTURE behavior OF lrb_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT LRB
		generic (sim : boolean := true);
    PORT(
         clk_p : IN  std_logic;
         clk_n : IN  std_logic;
         lrbA_in_p : IN  std_logic_vector(4 downto 0);
         lrbA_in_n : IN  std_logic_vector(4 downto 0);
         lrbB_in_p : IN  std_logic_vector(4 downto 0);
         lrbB_in_n : IN  std_logic_vector(4 downto 0);
         lrbC_in_p : IN  std_logic_vector(4 downto 0);
         lrbC_in_n : IN  std_logic_vector(4 downto 0);
         CCLK : IN  std_logic;
         CDATA : IN  std_logic;
         chip_ID : IN  std_logic_vector(2 downto 0);
         RXD_p : IN  std_logic;
         RXD_n : IN  std_logic;
         LED : OUT  std_logic_vector(4 downto 0);
         TXD_p : OUT  std_logic_vector(8 downto 0);
         TXD_n : OUT  std_logic_vector(8 downto 0);
         TXclk_p : OUT  std_logic;
         TXclk_n : OUT  std_logic;
         MDQ : INOUT  std_logic_vector(15 downto 0);
         MA : OUT  std_logic_vector(12 downto 0);
         MBA : OUT  std_logic_vector(1 downto 0);
         DM : OUT  std_logic_vector(1 downto 0);
         DQS : INOUT  std_logic_vector(1 downto 0);
         WE_n : OUT  std_logic;
         CAS_n : OUT  std_logic;
         RAS_n : OUT  std_logic;
         CS_n : OUT  std_logic;
         mclke : OUT  std_logic;
         mclk : OUT  std_logic;
         mclk_n : OUT  std_logic
        );
    END COMPONENT;
component ddr
  port(
      Clk: in std_logic;
      Clk_n: in std_logic;
      Cke: in std_logic;
      Cs_n: in std_logic;
      Ras_n: in std_logic;
      Cas_n: in std_logic;
      We_n: in std_logic;
      Ba: in std_logic_vector(1 downto 0);
      Addr: in std_logic_vector(12 downto 0);
      Dm: in std_logic_vector(1 downto 0);
      Dq: in std_logic_vector(15 downto 0);
      Dq_o: out std_logic_vector(15 downto 0);
      T_dq: out std_logic;
      Dqs: in std_logic_vector(1 downto 0);
      Dqs_o: out std_logic_vector(1 downto 0);
      T_dqs: out std_logic
  );
end component;
component ch_link
    Port ( en_tx : in  STD_LOGIC;
           cl_data : out  STD_LOGIC_VECTOR (4 downto 0));
end component;
    

   --Inputs
   signal clk_p : std_logic := '0';
   signal clk_n : std_logic := '0';
   signal lrbA_in_p : std_logic_vector(4 downto 0) := (others => '0');
   signal lrbA_in_n : std_logic_vector(4 downto 0) := (others => '1');
   signal lrbB_in_p : std_logic_vector(4 downto 0) := (others => '0');
   signal lrbB_in_n : std_logic_vector(4 downto 0) := (others => '1');
   signal lrbC_in_p : std_logic_vector(4 downto 0) := (others => '0');
   signal lrbC_in_n : std_logic_vector(4 downto 0) := (others => '1');
   signal en_tx : std_logic := '0';
   signal CCLK : std_logic := '0';
   signal CDATA : std_logic := '0';
   signal chip_ID : std_logic_vector(2 downto 0) := (others => '0');
   signal RXD_p : std_logic := '0';
   signal RXD_n : std_logic := '0';

	--BiDirs
   signal mdq : std_logic_vector(15 downto 0);
	SIGNAL dq_o :  std_logic_vector(15 downto 0);
	SIGNAL T_dq :  std_logic;
	SIGNAL dqs :  std_logic_vector(1 downto 0);
	SIGNAL dqs_o :  std_logic_vector(1 downto 0);
	SIGNAL T_dqs :  std_logic;

 	--Outputs
   signal LED : std_logic_vector(4 downto 0);
   signal TXD_p : std_logic_vector(8 downto 0);
   signal TXD_n : std_logic_vector(8 downto 0);
   signal TXclk_p : std_logic;
   signal TXclk_n : std_logic;
   signal MA : std_logic_vector(12 downto 0);
   signal MBA : std_logic_vector(1 downto 0);
   signal DM : std_logic_vector(1 downto 0);
   signal WE_n : std_logic;
   signal CAS_n : std_logic;
   signal RAS_n : std_logic;
   signal CS_n : std_logic;
   signal mclke : std_logic;
   signal mclk : std_logic;
   signal mclk_n : std_logic;

   -- Clock period definitions
   signal mdqp : std_logic_vector(15 downto 0);
	 SIGNAL dqsp :  std_logic_vector(1 downto 0);
   -- Clock period definitions
   constant clk_period : time := 6.666ns;
   signal TCLK_in : std_logic := '1';
   signal TCLK : std_logic := '1';
   signal polarity : std_logic_vector(11 downto 0) := (others => '0');
   signal clk : std_logic := '0';
   signal clk180 : std_logic := '0';
   signal reset : std_logic := '0';
   signal run : std_logic := '0';
   signal n_strobe : std_logic := '0';
   signal update_led : std_logic := '0';
   signal vme_cycle : std_logic := '0';
   signal addr_str : std_logic := '0';
   signal vme_read : std_logic := '0';
   signal rd_length : std_logic_vector(3 downto 0) := (others => '0');
   signal ledin : std_logic_vector(4 downto 0) := (others => '0');
   signal addr : std_logic_vector(15 downto 0) := (others => '0');
   signal we_byte : std_logic_vector(3 downto 0) := (others => '0');
   signal w_data : std_logic_vector(31 downto 0) := (others => '0');
   signal event_data_str : std_logic := '0';
   signal event_data_req : std_logic_vector(18 downto 0) := (others => '0');
   signal re_event_info : std_logic := '0';
   signal re_event_data : std_logic := '0';
   signal cl_data : std_logic_vector(4 downto 0) := (others => '0');

 	--Outputs
   signal LRB_ack : std_logic;
   signal lrb_data_dav : std_logic;
   signal lrb_data : std_logic_vector(31 downto 0);
   signal event_info_rdy : std_logic;
   signal event_info : std_logic_vector(35 downto 0);
   signal event_data_rdy : std_logic;
   signal event_data : std_logic_vector(32 downto 0);
   signal LRB_en : std_logic_vector(2 downto 0) := "111";
   signal cntr : std_logic_vector(15 downto 0) := (others => '0');
constant polarityA : std_logic_vector(3 downto 0) := x"3"; -- used to correct polarity assignment of input LVDS signals
constant polarityB : std_logic_vector(3 downto 0) := x"2"; -- used to correct polarity assignment of input LVDS signals
constant polarityC : std_logic_vector(3 downto 0) := x"6"; -- used to correct polarity assignment of input LVDS signals
 
BEGIN
i_ch_link: ch_link
    Port map( en_tx => en_tx,
           cl_data => cl_data);
lrbA_in_p <= cl_data(4) & (polarityA xor cl_data(3 downto 0));
lrbA_in_n <= not lrbA_in_p;
lrbB_in_p <= cl_data(4) & (polarityB xor cl_data(3 downto 0));
lrbB_in_n <= not lrbB_in_p;
lrbC_in_p <= cl_data(4) & (polarityC xor cl_data(3 downto 0));
lrbC_in_n <= not lrbC_in_p;
 
	-- Instantiate the Unit Under Test (UUT)
	mdqp <= "LLLLLLLLLLLLLLLL" when T_dq = '1' else dq_o;
	dqsp <= "HH" when T_dqs = '1' else dqs_o;
mdq <= mdqp after 1ns;
dqs <= dqsp after 2ns;
i_ddr: ddr port map(
      Clk => mclk,
      Clk_n => mclk_n,
      Cke => mclke,
		Dq => mdq,
		Dq_o => dq_o,
		T_dq => T_dq,
		Addr => ma,
		Ba => mba,
		Dm => dm,
		Dqs => dqs,
		Dqs_o => dqs_o,
		T_dqs => T_dqs,
		We_n => we_n,
		Ras_n => ras_n,
		Cas_n => cas_n,
		Cs_n => cs_n
			);
   uut: LRB generic map(sim => true) PORT MAP (
          clk_p => clk_p,
          clk_n => clk_n,
          lrbA_in_p => lrbA_in_p,
          lrbA_in_n => lrbA_in_n,
          lrbB_in_p => lrbB_in_p,
          lrbB_in_n => lrbB_in_n,
          lrbC_in_p => lrbC_in_p,
          lrbC_in_n => lrbC_in_n,
          CCLK => CCLK,
          CDATA => CDATA,
          chip_ID => chip_ID,
          RXD_p => RXD_p,
          RXD_n => RXD_n,
          LED => LED,
          TXD_p => TXD_p,
          TXD_n => TXD_n,
          TXclk_p => TXclk_p,
          TXclk_n => TXclk_n,
          MDQ => MDQ,
          MA => MA,
          MBA => MBA,
          DM => DM,
          DQS => DQS,
          WE_n => WE_n,
          CAS_n => CAS_n,
          RAS_n => RAS_n,
          CS_n => CS_n,
          mclke => mclke,
          mclk => mclk,
          mclk_n => mclk_n
        );
i_LRBTclkds: IBUFDS generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33") port map(i => TxCLK_p, ib => TxCLK_n, o => Tclk_in);
i_LRB0Tclk: bufg port map(i => Tclk_in, o => Tclk);
	i_LRB_link: LRB_link generic map(sim => true) PORT MAP(
		TCLKin => tclk,
		TD_P => TxD_p,
		TD_n => TxD_n,
		polarity => polarity,
		rCLK_P => clk_p,
		rCLK_n => clk_n,
		RD_P => rxd_p,
		RD_n => rxd_n,
		clk => clk,
		clk180 => clk180,
		reset => reset,
		run => run,
		n_strobe => n_strobe,
		update_led => update_led,
		vme_cycle => vme_cycle,
		addr_str => addr_str,
		vme_read => vme_read,
		rd_length => rd_length,
		LRB_ID => "001",
		LRB_en => lrb_en,
		led => ledin,
		addr => addr,
		we_byte => we_byte,
		w_data => w_data,
		lrb_test => '0',
		lrb_test_str => '0',
		lrb_test_data => x"00000000",
		LRB_ack => LRB_ack,
		event_data_str => event_data_str,
		event_data_req => event_data_req,
		re_event_info => re_event_info,
		re_event_data => re_event_data,
		reg_data_dav => LRB_data_dav,
		reg_data => LRB_data,
		event_info_rdy => event_info_rdy,
		event_info => event_info,
		event_data_rdy => event_data_rdy,
		event_data => event_data
	);
clk <= not clk after clk_period/2;
clk180 <= not clk;
--reset <= '1' when cntr = x"07a8" else '0';
--addr_str <= '1' when cntr = x"07e0" or cntr = x"07f0" or cntr = x"0800" or cntr = x"0810" or cntr = x"0820" or cntr = x"0830" else '0';
--vme_read <= '1' when cntr >= x"0800" and cntr < x"820" else '0';
--vme_cycle <= '1' when (cntr >= x"07e0" and cntr < x"07f0") or (cntr >= x"0800" and cntr < x"0810") or (cntr >= x"0820" and cntr < x"0830") else '0';
--we_byte <= x"f" when cntr = x"07e8" or cntr = x"0828" else x"0";
--addr <= x"46c0" when cntr < x"0820" else x"4400";
--w_data <= x"1234abcd" when cntr < x"07f0" else x"003f0264";
--run <= '1' when cntr > x"0840" else '0';
process(clk)
begin
	if(clk'event and clk = '1')then
		n_strobe <= not n_strobe;
		if(n_strobe = '0')then
			cntr <= cntr + 1;
		end if;
	end if;
end process;
   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for clk_period*560.5;
			run <= '1';
			wait for clk_period*2;
			reset <= '1';
			wait for clk_period*2;
			reset <= '0';
			wait for clk_period*40;
			en_tx <= '1';
--			addr <= x"46c0";
--			w_data <= x"abcd1234";
--			vme_cycle <= '1';
--			vme_read <= '0';
--			addr_str <= '1';
--			wait for clk_period*2;
--			addr_str <= '0';
--			wait until lrb_ack = '1';
--			we_byte <= x"f";
--			wait for clk_period*2;
--			we_byte <= x"0";
--			wait until lrb_ack = '1';
--			w_data <= x"abcd1235";
--			we_byte <= x"f";
--			wait for clk_period*2;
--			we_byte <= x"0";
--			wait until lrb_ack = '1';
--			w_data <= x"abcd1236";
--			we_byte <= x"f";
--			wait for clk_period*2;
--			we_byte <= x"0";
--			wait until lrb_ack = '1';
--			w_data <= x"abcd1237";
--			we_byte <= x"f";
--			wait for clk_period*2;
--			we_byte <= x"0";
--			wait until lrb_ack = '1';
--			w_data <= x"abcd1238";
--			vme_cycle <= '0';
--			addr_str <= '1';
--			wait for clk_period*2;
--			addr_str <= '0';
--			wait until lrb_ack = '1';
----			addr <= x"4400";
--			vme_cycle <= '1';
--			vme_read <= '1';
--			rd_length <= x"3";
--			addr_str <= '1';
--			wait for clk_period*2;
--			addr_str <= '0';
--			wait until lrb_ack = '1';
--			
      -- insert stimulus here 

      wait;
   end process;

END;
