--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   16:47:58 08/07/2008
-- Design Name:   
-- Module Name:   C:/iseproj/VME_dcc/u2/sdram_tb.vhd
-- Project Name:  u2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: sdram
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.VComponents.all;
 
ENTITY sdram_tb IS
END sdram_tb;
 
ARCHITECTURE behavior OF sdram_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT sdram_a
		generic (sim : boolean := false);
    PORT(
         reset : IN  std_logic;
         rst_DCM : IN  std_logic;
         clk : IN  std_logic;
         mclk_in : IN  std_logic;
         wr_rqst : IN  std_logic;
         wr_gnt : OUT  std_logic;
         wr_addr : IN  std_logic_vector(22 downto 0);
         wr_length : IN  std_logic_vector(5 downto 0);
         wr_data : IN  std_logic_vector(31 downto 0);
         wr_en : IN  std_logic;
         rd_rqst : IN  std_logic;
         rd_gnt : OUT  std_logic;
         rd_addr : IN  std_logic_vector(22 downto 0);
         rd_length : IN  std_logic_vector(5 downto 0);
         rd_en : IN  std_logic;
         rd_data : OUT  std_logic_vector(31 downto 0);
         mdq : INOUT  std_logic_vector(15 downto 0);
         maddr : OUT  std_logic_vector(12 downto 0);
         mba : OUT  std_logic_vector(1 downto 0);
         dm : OUT  std_logic_vector(1 downto 0);
         dqs : INOUT  std_logic_vector(1 downto 0);
         we_n : OUT  std_logic;
         ras_n : OUT  std_logic;
         cas_n : OUT  std_logic;
         cs_n : OUT  std_logic;
         mclke : OUT  std_logic;
         mclk : OUT  std_logic;
         mclk_n : OUT  std_logic
        );
    END COMPONENT;
component ddr
  port(
      Clk: in std_logic;
      Clk_n: in std_logic;
      Cke: in std_logic;
      Cs_n: in std_logic;
      Ras_n: in std_logic;
      Cas_n: in std_logic;
      We_n: in std_logic;
      Ba: in std_logic_vector(1 downto 0);
      Addr: in std_logic_vector(12 downto 0);
      Dm: in std_logic_vector(1 downto 0);
      Dq: in std_logic_vector(15 downto 0);
      Dq_o: out std_logic_vector(15 downto 0);
      T_dq: out std_logic;
      Dqs: in std_logic_vector(1 downto 0);
      Dqs_o: out std_logic_vector(1 downto 0);
      T_dqs: out std_logic
  );
end component;
    

   --Inputs
   signal reset : std_logic := '1';
   signal rst_DCM : std_logic := '1';
   signal clk : std_logic := '0';
   signal mclk_in : std_logic := '0';
   signal wr_rqst : std_logic := '0';
   signal wr_addr : std_logic_vector(22 downto 0) := (others => '0');
   signal wr_length : std_logic_vector(5 downto 0) := (others => '0');
   signal wr_data : std_logic_vector(31 downto 0) := (others => '0');
   signal wr_en : std_logic := '0';
   signal rd_rqst : std_logic := '0';
   signal rd_addr : std_logic_vector(22 downto 0) := (others => '0');
   signal rd_length : std_logic_vector(5 downto 0) := (others => '0');
   signal rd_en : std_logic := '0';

	--BiDirs
   signal mdq : std_logic_vector(15 downto 0);
	SIGNAL dq_o :  std_logic_vector(15 downto 0);
	SIGNAL T_dq :  std_logic;
	SIGNAL dqs :  std_logic_vector(1 downto 0);
	SIGNAL dqs_o :  std_logic_vector(1 downto 0);
	SIGNAL T_dqs :  std_logic;

 	--Outputs
   signal wr_gnt : std_logic;
   signal rd_gnt : std_logic;
   signal rd_data : std_logic_vector(31 downto 0);
   signal maddr : std_logic_vector(12 downto 0);
   signal mba : std_logic_vector(1 downto 0);
   signal dm : std_logic_vector(1 downto 0);
   signal we_n : std_logic;
   signal ras_n : std_logic;
   signal cas_n : std_logic;
   signal cs_n : std_logic;
   signal mclke : std_logic;
   signal mclk : std_logic;
   signal mclk_n : std_logic;

   signal mdqp : std_logic_vector(15 downto 0);
	 SIGNAL dqsp :  std_logic_vector(1 downto 0);
   -- Clock period definitions
   constant clk_period : time := 6.666ns;
 
signal cntr : std_logic_vector(15 downto 0) := (others => '0');
BEGIN
--   KEEPER_0 : KEEPER
--   port map (
--      O => dqs(0)     -- Keeper output (connect directly to top-level port)
--   );
--   KEEPER_1 : KEEPER
--   port map (
--      O => dqs(1)     -- Keeper output (connect directly to top-level port)
--   );
wr_length <= "000100";
rd_length <= "000000";
	mdqp <= "LLLLLLLLLLLLLLLL" when T_dq = '1' else dq_o;
	dqsp <= "HH" when T_dqs = '1' else dqs_o;
mdq <= mdqp after 1ns;
dqs <= dqsp after 2ns;
i_ddr: ddr port map(
      Clk => mclk,
      Clk_n => mclk_n,
      Cke => mclke,
		Dq => mdq,
		Dq_o => dq_o,
		T_dq => T_dq,
		Addr => maddr,
		Ba => mba,
		Dm => dm,
		Dqs => dqs,
		Dqs_o => dqs_o,
		T_dqs => T_dqs,
		We_n => we_n,
		Ras_n => ras_n,
		Cas_n => cas_n,
		Cs_n => cs_n
			);
 
	-- Instantiate the Unit Under Test (UUT)
   uut: sdram_a generic map(sim => true) PORT MAP (
          reset => reset,
          rst_DCM => rst_DCM,
          clk => clk,
					mclk_in => mclk_in,
          wr_rqst => wr_rqst,
          wr_gnt => wr_gnt,
          wr_addr => wr_addr,
          wr_length => wr_length,
          wr_data => wr_data,
          wr_en => wr_en,
          rd_rqst => rd_rqst,
          rd_gnt => rd_gnt,
          rd_addr => rd_addr,
          rd_length => rd_length,
          rd_en => rd_en,
          rd_data => rd_data,
          mdq => mdq,
          maddr => maddr,
          mba => mba,
          dm => dm,
          dqs => dqs,
          we_n => we_n,
          ras_n => ras_n,
          cas_n => cas_n,
          cs_n => cs_n,
          mclke => mclke,
          mclk => mclk,
          mclk_n => mclk_n
        );

   -- Clock process definitions
wr_data <= x"0000" & cntr;
wr_en <= '1' when cntr > x"0f60" and cntr < x"0f70" else '0';
rd_en <= '1' when cntr > x"0fb0" and cntr < x"0fb9" else '0';
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
mclk_in <= clk after clk_period/4;
process(clk)
begin
  if(clk'event and clk = '1')then
	  cntr <= cntr + 1;
		if(cntr = x"0f80" or cntr = x"0f98")then
		  wr_rqst <= '1';
		elsif(wr_gnt = '1')then
		  wr_rqst <= '0';
		end if;
		if(wr_gnt = '1')then
		  rd_rqst <= '1';
		elsif(rd_gnt = '1')then
		  rd_rqst <= '0';
		end if;
		if(wr_gnt = '1')then
		  wr_addr <= wr_addr + 5;
		end if;
		if(rd_gnt = '1')then
		  rd_addr <= rd_addr + 4;
		end if;
		if(cntr = x"0004")then
		  rst_DCM <= '0';
			reset <= '0';
		end if;
	end if;
end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for 100ms;	

      wait for clk_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
